/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	getambassadoriov1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTLSContexts implements TLSContextInterface
type FakeTLSContexts struct {
	Fake *FakeGetambassadorV1
	ns   string
}

var tlscontextsResource = schema.GroupVersionResource{Group: "getambassador.io", Version: "v1", Resource: "tlscontexts"}

var tlscontextsKind = schema.GroupVersionKind{Group: "getambassador.io", Version: "v1", Kind: "TLSContext"}

// Get takes name of the tLSContext, and returns the corresponding tLSContext object, and an error if there is any.
func (c *FakeTLSContexts) Get(name string, options v1.GetOptions) (result *getambassadoriov1.TLSContext, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tlscontextsResource, c.ns, name), &getambassadoriov1.TLSContext{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.TLSContext), err
}

// List takes label and field selectors, and returns the list of TLSContexts that match those selectors.
func (c *FakeTLSContexts) List(opts v1.ListOptions) (result *getambassadoriov1.TLSContextList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tlscontextsResource, tlscontextsKind, c.ns, opts), &getambassadoriov1.TLSContextList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &getambassadoriov1.TLSContextList{ListMeta: obj.(*getambassadoriov1.TLSContextList).ListMeta}
	for _, item := range obj.(*getambassadoriov1.TLSContextList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tLSContexts.
func (c *FakeTLSContexts) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tlscontextsResource, c.ns, opts))

}

// Create takes the representation of a tLSContext and creates it.  Returns the server's representation of the tLSContext, and an error, if there is any.
func (c *FakeTLSContexts) Create(tLSContext *getambassadoriov1.TLSContext) (result *getambassadoriov1.TLSContext, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tlscontextsResource, c.ns, tLSContext), &getambassadoriov1.TLSContext{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.TLSContext), err
}

// Update takes the representation of a tLSContext and updates it. Returns the server's representation of the tLSContext, and an error, if there is any.
func (c *FakeTLSContexts) Update(tLSContext *getambassadoriov1.TLSContext) (result *getambassadoriov1.TLSContext, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tlscontextsResource, c.ns, tLSContext), &getambassadoriov1.TLSContext{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.TLSContext), err
}

// Delete takes name of the tLSContext and deletes it. Returns an error if one occurs.
func (c *FakeTLSContexts) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tlscontextsResource, c.ns, name), &getambassadoriov1.TLSContext{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTLSContexts) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tlscontextsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &getambassadoriov1.TLSContextList{})
	return err
}

// Patch applies the patch and returns the patched tLSContext.
func (c *FakeTLSContexts) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *getambassadoriov1.TLSContext, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tlscontextsResource, c.ns, name, pt, data, subresources...), &getambassadoriov1.TLSContext{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.TLSContext), err
}
